#ifndef _GMPI_H
#define _GMPI_H

#include <mpi.h>

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

// MPI functions wrappers

// Grid-enabled

int MPG_Init(int *argc,char ***argv);
int MPG_Comm_size(MPI_Comm comm, int *size);
int MPG_Comm_rank(MPI_Comm comm, int *rank);

int MPG_Send(void *data,int size, MPI_Datatype type,int address,int tag,MPI_Comm comm);
int MPG_Recv(void *data, int size, MPI_Datatype type, int address, int tag, MPI_Comm comm, MPI_Status *status);

int MPG_Finalize();

int MPG_Sendrecv(void *sBuf, int sCount, MPI_Datatype sType, int address, int sTag,
                 void *rBuf, int rCount, MPI_Datatype rType, int source,
                 int rTag, MPI_Comm comm, MPI_Status *status);
int MPG_Bcast (void *buf, int count, MPI_Datatype datatype, int root, MPI_Comm comm);

int MPG_Reduce(void *in, void *out, int size, MPI_Datatype type, MPI_Op op, int root, MPI_Comm comm);
int MPG_Allreduce(void *in, void *out, int size, MPI_Datatype type, MPI_Op op, MPI_Comm comm);
int MPG_Barrier(MPI_Comm );

#define MPI_Init MPG_Init

#define MPI_Comm_size MPG_Comm_size
#define MPI_Comm_rank MPG_Comm_rank
#define MPI_Send MPG_Send
#define MPI_Recv MPG_Recv
#define MPI_Finalize MPG_Finalize

#define MPI_Sendrecv MPG_Sendrecv
#define MPI_Bcast MPG_Bcast
#define MPI_Reduce MPG_Reduce
#define MPI_Allreduce MPG_Allreduce
#define MPI_Barrier MPG_Barrier

#endif
