#ifndef _TYPES_H
#define _TYPES_H

// grid data types
// C types
#define TYPE_CHAR      10
#define TYPE_SHORT     11
#define TYPE_INT       12
#define TYPE_LONG      13
#define TYPE_UCHAR     14
#define TYPE_USHORT    15
#define TYPE_UNSIGNED  16
#define TYPE_ULONG     17
#define TYPE_FLOAT     18
#define TYPE_DOUBLE    19
#define TYPE_LDOUBLE   20

// MPI_OP internal codes (integer)
#define MPI_OP_MAX     1
#define MPI_OP_MIN     2
#define MPI_OP_SUM     3
#define MPI_OP_PROD    4
#define MPI_OP_LAND    5
#define MPI_OP_BAND    6
#define MPI_OP_LOR     7
#define MPI_OP_BOR     8
#define MPI_OP_LXOR    9
#define MPI_OP_BXOR    10
#define MPI_OP_MAXLOC  11
#define MPI_OP_MINLOC  12

///////////////////////////////////////////////////////////////////////////////

// Convert GRID type to MPI type
int convertGrid_MPI(int gridType, MPI_Datatype &MPI_type, int &memSize);
// Convert MPI type to GRID type
int convertMPI_Grid(MPI_Datatype MPI_type, int &gridType, int &memSize);

// convert a code (integer) to MPI_OP C++ type
int convertMPI_OP_C(int code, MPI_Op &op);

#endif
