
// Simple example for NumGRID project
// This programs tests speed of MPI_Send

// used MPI_Send, MPI_Recv
// ring - swap data


#include <stdio.h>
#include <sys/timeb.h>

//#include <mpi.h>
#include "gmpi.h"

#define SEND_TIMES 5000
#define DATA_SIZE  9970

float data[DATA_SIZE];
struct timeb startTime, endTime;

int main(int argc, char **argv)
{
 int rank,size,left,right;
 int Tag=10;
 int i;
 float save;
 MPI_Status Status;
 FILE *fp;

 if (MPI_Init(&argc, &argv) != MPI_SUCCESS)
 {
  MPI_Finalize();
  return 1;
 };

 MPI_Comm_rank(MPI_COMM_WORLD, &rank);
 MPI_Comm_size(MPI_COMM_WORLD, &size);

 printf("Task rank %d started\n", rank);

 if (rank==0) left=size-1; else left=rank-1;
 if (rank==size-1) right=0; else right=rank+1;

 data[0] = rank;

 fp = stdout;
// if (rank == 0) fp =fopen("0","wt");
 //else fp =fopen( "1","wt");

 ftime(&startTime); 
 for (i = 0; i< SEND_TIMES;i ++)
 {
  if(rank%2)
  {
    MPI_Send(&data,DATA_SIZE,MPI_FLOAT,right,Tag,MPI_COMM_WORLD);
//    fprintf(fp,"Data = %f\n", data[0]);
    save = data[0];
    MPI_Recv(&data,DATA_SIZE,MPI_FLOAT,left,Tag,MPI_COMM_WORLD,&Status);
//    fprintf(fp,"Data = %f\n", data[0]);
    data[0] = save;
  }
  else
  {
//    fprintf(fp,"Data = %f\n", data[0]);
    save = data[0];
    MPI_Recv(&data,DATA_SIZE,MPI_FLOAT,left,Tag,MPI_COMM_WORLD,&Status);
//    fprintf(fp,"Data = %f\n", data[0]);
    data[0] = save;
    MPI_Send(&data,DATA_SIZE,MPI_FLOAT,right,Tag,MPI_COMM_WORLD);
  }
 }
 ftime(&endTime);

  float diff = (float)(endTime.time - startTime.time);
  diff += (float)(endTime.millitm - startTime.millitm) / 1000;

  printf("Buffer size = %d, Repeat times = %d, Time spent = %f s \n",DATA_SIZE, SEND_TIMES, diff );
  printf("Speed = %f Mb/s \n", (sizeof(float) * (DATA_SIZE+30) * SEND_TIMES)/ ((diff) * 1024 * 1024));

 MPI_Finalize();
 return 0;
}
