#ifndef _ENCSOCK_H
#define _ENCSOCK_H

#include <openssl/des.h>
#include <openssl/rsa.h>

#include "net.h"

//////////////////////////////////////////////////////////////////////
typedef struct
{
	int soc;

#if OPENSSL_VERSION_NUMBER >= 0x00907000L
	DES_cblock iv;
	DES_key_schedule ks1,ks2;
#else
	des_cblock iv;
	des_key_schedule ks1,ks2;
#endif

	char *error;
	char *syserror;
} _ENCSOCK;

typedef void* ENCSOCK;

#ifdef _WIN32
  #define MSG_WAITALL 0
#endif


//////////////////////////////////////////////////////////////////////
ENCSOCK esockConnect(int s);
ENCSOCK esockAccept(int s, void *_rsa);

int esockWritePacket(ENCSOCK es, Packet *pack);
int esockReadPacket(ENCSOCK es, Packet *pack);

int writeMessage(ENCSOCK es, char *mes, int sig = SIG_OK);
int readMessage(ENCSOCK es, char **mes, int &len, int &sig);

int writeFile(ENCSOCK es, std::string filename, std::string dir = "");
int readFile(ENCSOCK es, std::string filename = "", std::string dir = "");

int writeFileList(ENCSOCK es, StringList lst, std::string dir = "");
int readFileList(ENCSOCK es, std::string dir = "");

#endif
