
// Print diffirent messages to the file or stdout

#include <string.h>
#include <stdarg.h>

#include "log.h"

//////////////////////////////////////////////////////////////////////////////
Log::Log()
{
  fp_ = stdout;
  pref = "";
}

//////////////////////////////////////////////////////////////////////////////
Log::~Log()
{
  close();
}

//////////////////////////////////////////////////////////////////////////////
int Log::open(char *filename)
{
  if (strcmp(filename,"") == 0)
  {
    fp_ = stdout;
    return 1;
  };

  if ((fp_ = fopen(filename, "wt")) == NULL)
  {
    fp_ = stdout;
    return 0;
  }

  return 1;
};

//////////////////////////////////////////////////////////////////////////////
void Log::close()
{
  fflush(fp_);
  if ((fp_!= NULL) && (fp_!= stdout))
    fclose(fp_);
};

//////////////////////////////////////////////////////////////////////////////
void Log::print(char *str,...)
{
  if (fp_ == NULL) return;

  printf("%s", pref.c_str());
  va_list args;
  va_start(args, str);
  
  vfprintf(fp_, str, args);
  fflush(fp_);
};

//////////////////////////////////////////////////////////////////////////////
void Log::setPrefix(char *newPref)
{
  pref = newPref;
};
