// All syntax (keywords, identifiers) for NumGRID project description

#ifndef _PROJECTSYNTAX_H
#define _PROJECTSYNTAX_H

///////////////////////////////////////////////////////////////////////////////
#define PAR_SERVER_NAME          0
#define PAR_SERVER_PORT          1
#define PAR_USERNAME             2
#define PAR_PASSWORD             3

#define PAR_INTERNAL_HOST_NAME  10
#define PAR_GATEWAY_PORT        11
#define PAR_NP                  12
#define PAR_MAKEFILE            13
#define PAR_SOURCE_DIR          14
#define PAR_SOURCE_FILES        15
#define PAR_INPUT_DIR           16
#define PAR_INPUT_FILES         17
#define PAR_OUTPUT_DIR          20
#define PAR_OUTPUT_FILES        21
#define PAR_WORK_DIR            22
#define PAR_NEED_RUN_TASK       23
#define PAR_EXECUTABLE          30
#define PAR_EXEC_ARGS           31
#define PAR_EXEC_ENV            32

#define PAR_ERROR               -1

///////////////////////////////////////////////////////////////////////////////
struct Keyword
{
  char *name;
  int   id;
};

///////////////////////////////////////////////////////////////////////////////
const Keyword SCRIPT_KEYWORDS[] = {{"ServerName"           , PAR_SERVER_NAME},
                                   {"ServerPort"           , PAR_SERVER_PORT},
                                   {"Username"             , PAR_USERNAME},
                                   {"Password"             , PAR_PASSWORD},
                                   {"InternalHostName"     , PAR_INTERNAL_HOST_NAME},
                                   {"GatewayPort"          , PAR_GATEWAY_PORT},

                                   {"NP"                   , PAR_NP},

                                   {"Makefile"             , PAR_MAKEFILE},
                                   {"SourceDir"            , PAR_SOURCE_DIR},
                                   {"SourceFiles"          , PAR_SOURCE_FILES},

                                   {"InputDir"             , PAR_INPUT_DIR},
                                   {"InputFiles"           , PAR_INPUT_FILES},
                                   {"OutputDir"            , PAR_OUTPUT_DIR},
                                   {"OutputFiles"          , PAR_OUTPUT_FILES},

                                   {"WorkDir"              , PAR_WORK_DIR},
                                   {"RunTask"              , PAR_NEED_RUN_TASK},
                                   {"Executable"           , PAR_EXECUTABLE},
                                   {"ExecArgs"             , PAR_EXEC_ARGS},
                                   {"ExecEnv"              , PAR_EXEC_ENV}};

const int KEYWORDS_NUM = 19;


#endif
