#ifndef _SERVERCONFIG_H
#define _SERVERCONFIG_H


//#pragma warning(disable:4786)

//#include <string>

//using namespace std;
#include "common.h"

#include "scripts.h"
#include "multi_os.h"

// Error codes
#define ERR_WRONG_VALUE      200
#define ERR_WRONG_QUEUETYPE  202
#define ERR_UNKNOWN_IDENT    203
#define ERR_UNKNOWN_VAR_NAME 204
#define ERR_WRONG_PARAMSTYPE 205
///////////////////////////////////////////////////////////////////////////////
enum QueueType
{
  QUEUE_PBS,
  QUEUE_SGE,
  QUEUE_CUSTOM,
  QUEUE_MPICH,
  QUEUE_LAMMPI
};

enum ParamsPassType
{
  PARAMS_ENV,
  PARAMS_ARG
};

///////////////////////////////////////////////////////////////////////////////
class ServerConfig
{
public:
  ServerConfig(); 
  int loadInfo(char * filename = SERVER_CFG_FILE);
  void clear(void);
  char *getErrorText();

  int errCode;

  QueueType queue;
  string scriptBeforeRun; 
  string runScript;
  string addScript;
  ParamsPassType paramsPassMethod;
  int jmanLife;

private:
  int parseVar(NGVarInfo & var);
  int getVarCode(string varName);
};

#endif
