// Syntax (keywords, identifiers) for server(cluster) config file

#ifndef _SERVERSYNTAX_H
#define _SERVERSYNTAX_H

///////////////////////////////////////////////////////////////////////////////
#define PAR_QUEUE            1

#define PAR_QUEUE_MPICH      2
#define PAR_QUEUE_SGE        3
#define PAR_QUEUE_CUSTOM     4
#define PAR_QUEUE_PBS        5
#define PAR_QUEUE_LAMMPI     6

#define PAR_RUN_SCRIPT       11
#define PAR_ADD_SCRIPT       12

#define PAR_PASS_TYPE        20
#define PAR_PASS_ENV         21
#define PAR_PASS_ARG         22

#define PAR_JMAN_LIFE        30

#define PAR_ERROR            -1

///////////////////////////////////////////////////////////////////////////////
struct Keyword
{
  char *name;
  int   id;
};

///////////////////////////////////////////////////////////////////////////////
const Keyword SCRIPT_KEYWORDS[] = {{"QueueType"                 , PAR_QUEUE},
                                   {"RunScript"                 , PAR_RUN_SCRIPT},
                                   {"AddScript"                 , PAR_ADD_SCRIPT},
                                   {"MPICH"                     , PAR_QUEUE_MPICH},
                                   {"LAMMPI"                    , PAR_QUEUE_LAMMPI},
                                   {"SGE"                       , PAR_QUEUE_SGE},
                                   {"Custom"                    , PAR_QUEUE_CUSTOM},
                                   {"PBS"                       , PAR_QUEUE_PBS},
                                   {"ParamsPassMethod"          , PAR_PASS_TYPE},
                                   {"Env"                       , PAR_PASS_ENV},
                                   {"Arg"                       , PAR_PASS_ARG},
				   {"JobmanagerLifeTime"        , PAR_JMAN_LIFE}};
				   
const int KEYWORDS_NUM = 12;


#endif
