// TaskCtrl.h: interface for the TaskCtrl class.
//
///////////////////////////////////////////////////////////////////////////////
#ifndef _TASKCTRL_H
#define _TASKCTRL_H

#include "multi_os.h"
#include "projectinfo.h"
#include "serverconfig.h"

///////////////////////////////////////////////////////////////////////////////
class TaskCtrl  
{
public:
  int loadServerInfo(string serverConfigFile = SERVER_CFG_FILE);
  TaskCtrl();
  virtual ~TaskCtrl();

  void init(ProjectInfo info, int myIndex, string ngPath);
  int run();

  ServerConfig serverConfig;

private:
  int runSGE();
  int runMPI();
  int runCustom();
  char *genRunScriptName();
  int makeAllScripts();
  int prepareRunScript(char *filenameSrc,char *filenameDst);

  int myIndex_;
  ProjectInfo info_;
  string ngPath_;
};

#endif 
