

#ifdef _WIN32
  #include <direct.h>
#else
#endif

#include <openssl/evp.h>

#pragma warning(disable:4786)

#include "../Shared/net.h"

#include "main.h"
#include "client.h"

//////////////////////////////////////////////////////////////////////
// Process signals from the server
//void Client::processSignal(int sig, char *mes)
int Client::readServAnswer()
{
  char *mes = NULL;
  int len;
  int sig;
  char str[255]="";

  do
  {
    if (!readMessage(es, &mes, len, sig)) return 0;
    strncpy(str, mes, len);
    str[len] = 0;

    if (sig == SIG_CONT)
    {
      if (len >1) print("%s", str);
      continue; 
    };
    if (sig == SIG_OK) 
    {
      if (len >1) print("%s", str);
      break;
    }
    if (sig == SIG_ERROR)
    {
      if (len >1) print("%s", str);
      closeSocket(_es->soc);
      closeNetwork();
      exit(0);
    };

    free(mes);
  }
  while (true);

  return 1;
};

//////////////////////////////////////////////////////////////////////////////
void Client::print(char *str,...)
{
  printf("%s : ", project.serverList[myPos].blockName.c_str() );
  va_list args;
  va_start(args, str);
  
  vprintf(str, args);
};

//////////////////////////////////////////////////////////////////////
#ifdef _WIN32
DWORD WINAPI clientThread(LPVOID ptr)
#else
void *clientThread(void *ptr)
#endif
{
  char buf[128];
  int soc;
  char *mes = NULL;
  Client cl;
  int i,j;
  Packet pack;

  cl = *((Client *)ptr);

  soc = callSocket((char *)cl.project.serverList[cl.myPos].serverName.c_str(),
                   cl.project.serverList[cl.myPos].serverPort);
  if (soc == -1) return 0;

  cl.es = esockConnect(soc);
  cl._es=(_ENCSOCK *)cl.es;
  if(!cl.es)
  {
    cl.print("ERROR. Can't establish security context\n");
    closeSocket(cl._es->soc);
    return 0;
  }

  sprintf(buf,"%s:%s",cl.project.serverList[cl.myPos].username.c_str(),
          cl.project.serverList[cl.myPos].password.c_str());

  pack.header.signal  = SIG_OK;
  pack.header.size = strlen(buf);
  pack.data        = buf;

  if(!esockWritePacket(cl.es, &pack))
  {
    cl.print("ERROR. Can't upload client parameters\n");
    closeSocket(cl._es->soc);
    return 0;
  }
  if (!cl.readServAnswer()) return 0;

  if (!writeFile(cl.es, cl.projectFilename))
  {
    cl.print("ERROR. Can't upload project file\n");
    closeSocket(cl._es->soc);
    return 0;
  };

  if (!writeMessage(cl.es, "", cl.myPos))
  {
    cl.print("ERROR. Can't write message\n");
    closeSocket(cl._es->soc);
    return 0;
  };

  for (i =0; i < cl.args->size(); i++)
  {
    bool foundNum = false;

    if ((*cl.args)[i].vars.size() == 0) foundNum = true;
    else
    {  //not all servers are operated by this command
      for (j =0; j < (*cl.args)[i].vars.size(); j++)
        if (cl.myPos == (*cl.args)[i].vars[j]) foundNum = true;
    }

    if (!foundNum) continue;

    writeMessage(cl.es, "", (*cl.args)[i].sig);

    switch ((*cl.args)[i].sig)
    {
      case SIG_JOB_BUILD   : cl.print("Building new job...\n");
                             if (!writeFile(cl.es, cl.project.serverList[cl.myPos].makefile,
                                            cl.project.serverList[cl.myPos].sourceDir))
                             {
                               cl.print("ERROR. Can't upload 'makefile'\n");
                               closeSocket(cl._es->soc);
                               return 0;
                             };
                             if (!writeFileList(cl.es, cl.project.serverList[cl.myPos].sourceFiles,
                                                cl.project.serverList[cl.myPos].sourceDir))
                             {
                               cl.print("ERROR. Can't upload sourceFiles\n");
                               closeSocket(cl._es->soc);
                               return 0;
                             };
                             if (!cl.readServAnswer()) return 0;
                             break;
      case SIG_JOB_PUTDATA : cl.print("Uploading input data...\n");
                             if (!writeFileList(cl.es, cl.project.serverList[cl.myPos].inputFiles,
                                                cl.project.serverList[cl.myPos].inputDir))
                             {
                               cl.print("ERROR. Can't upload inputFiles\n");
                               closeSocket(cl._es->soc);
                               return 0;
                             };
                             if (!cl.readServAnswer()) return 0;
                             break;
      case SIG_JOB_GETDATA : cl.print("Downloading results...\n");
                             if (!readFileList(cl.es, cl.project.serverList[cl.myPos].outputDir))
                             {
                               cl.print("ERROR. Can't download outputFiles\n");
                               closeSocket(cl._es->soc);
                               return 0;
                             };
                             if (!cl.readServAnswer()) return 0;
                             break;
      case SIG_JOB_RUN_MPI : cl.print("Running new grid-mpi job....\n");
                             if (!cl.readServAnswer()) return 0;
                             break;
      case SIG_JOB_RUN     : cl.print("Running new remote job....\n");
                             if (!cl.readServAnswer()) return 0;
                             break;
      case SIG_JOB_KILL    : cl.print("Killing remote job\n");
                             if (!cl.readServAnswer()) return 0;
                             break;
      case SIG_JOB_ALLKILL : cl.print("Killing all remote jobs for this user\n");
                             if (!cl.readServAnswer()) return 0;
                             break;
    };

  };


  //writeMessage(cl.es, "!!!!!!!!!!!!!!!!!!!!1", 555);

  closeSocket(cl._es->soc);
  return 0;
};
